/******************************************************************************
 boost.h - main include file for boosting stuff
******************************************************************************/

/* data structures */
typedef enum {RULESET,RULE} concept_kind_t;

typedef struct boosted_concept_s {
    concept_kind_t hyp_kind;
    vec_t *weak_hyp;   
    vec_t *wt;
} boosted_concept_t;

typedef concept_t weak_ruleset_t;

typedef struct weak_rule_s {
    rule_t *rule;
    ex_count_t *dist;
} weak_rule_t;


/* boost.c functions */
boosted_concept_t *boost_model(DATA *,DATA *);
void fprint_boost_concept(FILE *,boosted_concept_t *); 
void fshow_boost_concept(FILE *,boosted_concept_t *); 
double boost_error_rate(boosted_concept_t *,DATA *); 
symbol_t *boost_classify(boosted_concept_t *,vec_t *); 
#define print_boost_concept(c) fprint_boost_concept(stdout,(c))

/* weak_rule.c functions */
weak_rule_t *wrule_model(DATA *);
symbol_t *wrule_classify(weak_rule_t *,vec_t *);
double wrule_error_rate(weak_rule_t *,DATA *);
void fprint_wrule(FILE *,weak_rule_t *);
void fshow_wrule(FILE *,weak_rule_t *);
#define print_wrule(wr) fprint_wrule(stdout,(wr))

typedef enum {MINCL,MAXCL,ALLCL} class_spec_t;

/* global variables */
extern int N_boost;
extern char *Weak_learner;
extern class_spec_t Find_rule_class_spec;
