/******************************************************************************
 soft.h - main include file for soft ripper
******************************************************************************/

/* data structures */

typedef struct soft_concept_s {
    vec_t *rules;           /* vector of soft_rule_t */
} soft_concept_t;

typedef struct soft_rule_s {
    symbol_t *conseq;
    vec_t *antec;       /* a vector of gsym_t */
    vec_t *deriv;       /* a vector of deriv_step_t */
    double *pref_wt;    /* array of weights of rule prefixes */
} soft_rule_t;

/* soft.c functions */
soft_concept_t *soft_model(DATA *);
void fprint_soft_concept(FILE *,soft_concept_t *); 
void fshow_soft_concept(FILE *,soft_concept_t *); 
double soft_error_rate(soft_concept_t *,DATA *); 
symbol_t *soft_classify(soft_concept_t *,vec_t *); 
#define print_soft_concept(c) fprint_soft_concept(stdout,(c))
void fprint_srule(FILE *,soft_rule_t *);
void fshow_srule(FILE *,soft_rule_t *);
#define print_srule(wr) fprint_srule(stdout,(wr))

typedef enum {MINCL,MAXCL,ALLCL} class_spec_t;

/* global variables */
extern int N_boost;
extern class_spec_t Find_rule_class_spec;
